# Package Tester
This application executes pytest on specified packages, returning
a summary of passes, failures, skips, and errors. A "verbose" command-
line option includes detail for individual tests.

## Usage
Package Tester is invoked by the **package-tester** console script
included in <code>package_tester/setup.py</code>:

    package-tester pkg1 [-v|--verbose][pkg2 pkg3 ... pkg N]'
*pkg* arguments are names of workspaces packages to be tested;
e.g., **datafetcher** or **shared.channels**

Package names need not be fully qualified. In the event that more
than one package is found for a given package name, user will be
notified that they must be more specific.

The *verbose* flag results in more detailed output. For example:

regular output:

    $ package-tester dummy_tests
    5 passes, 0 errors, 2 failures, 0 skipped; elapsed time: 0.04s
    
verbose output:
  
    $ package-tester -v dummy_tests
    ============================= test session starts ==============================
    platform darwin -- Python 3.8.6, pytest-5.4.3, py-1.10.0, pluggy-0.13.1
    rootdir: /Users/jgoldste/Projects/data, inifile: setup.cfg
    collected 7 items
    ../dummy_tests/always_fail/test_always_fails.py FF"I am the walrus"
    .
    ../dummy_tests/always_pass/test_always_passes.py ..
    ../dummy_tests/always_pass/test_always_passes_too.py ..
    =================================== FAILURES ===================================
    ______________________________ test_croak_and_die ______________________________
    def test_croak_and_die():
    >       pytest.fail("I'm melting! I'm melting!")
    E       Failed: I'm melting! I'm melting!
    ../dummy_tests/always_fail/test_always_fails.py:5: Failed
    ____________________________ test_but_but_its_true _____________________________
    def test_but_but_its_true():
    >       assert 'Janet' == 'Codemeister'
    E       AssertionError: assert 'Janet' == 'Codemeister'
    E         - Codemeister
    E         + Janet
    ../dummy_tests/always_fail/test_always_fails.py:9: AssertionError
    =========================== short test summary info ============================
    FAILED ../dummy_tests/always_fail/test_always_fails.py::test_croak_and_die - ...
    FAILED ../dummy_tests/always_fail/test_always_fails.py::test_but_but_its_true
    ========================= 2 failed, 5 passed in 0.04s ==========================
    5 passes, 0 errors, 2 failures, 0 skipped; elapsed time: 0.04s
    
Note that both options print the summary line.
